var objTxtbgfixerBrowser = {

	onload: function (ndTarget)
	{
		if ( ! gPrefService.prefHasUserValue('txtbgfixer.enabled') )
			gPrefService.setBoolPref( 'txtbgfixer.enabled', true );

		if ( ! gPrefService.getBoolPref('txtbgfixer.enabled') ||
			! gPrefService.getBoolPref('browser.display.use_document_colors') ) return;

		ndDocument = ndTarget.originalTarget;
		ndBody = ndDocument.getElementsByTagName("body")[0]; if (ndBody==null) return;

		sTxtcolor = ndBody.getAttribute("text");
		sBgcolor = ndBody.getAttribute("bgcolor");

		if ( sBgcolor && !sTxtcolor ) {
			if ( sBgcolor != "#000000" ) ndBody.setAttribute("text", "#000000");
		}
		else if ( !sBgcolor && sTxtcolor ) {
			if (sTxtcolor != "#FFFFFF" ) ndBody.setAttribute("bgcolor", "#FFFFFF");
		}
		else if ( !sBgcolor && !sTxtcolor ) {
			aTxtcolor = this.rgbToArray(ndDocument.defaultView.getComputedStyle(ndBody,'').getPropertyValue("color"));
			aBgcolor = this.rgbToArray(ndDocument.defaultView.getComputedStyle(ndBody,'').getPropertyValue("background-color"));
			if ( !aTxtcolor ) aTxtcolor = this.hexToArray(gPrefService.getCharPref('browser.display.foreground_color'));
			if ( !aBgcolor ) aBgcolor = this.hexToArray(gPrefService.getCharPref('browser.display.background_color'));

			if ( this.arrayRgbColorsSimilar(aTxtcolor, aBgcolor, 102) ) {
				ndBody.setAttribute("text", "#000000");
				ndBody.setAttribute("bgcolor", "#FFFFFF");
			}
			else if ( ndTD = ndDocument.getElementsByTagName("td") ) {
				for ( i = 0; i < ndTD.length; ++i ) {
					if ( ndTD[i].getAttribute("bgcolor") ) {
						ndBody.setAttribute("text", "#000000");
						ndBody.setAttribute("bgcolor", "#FFFFFF");
						break;
					}
				}
			}
		}

		if ( ndDocument.getElementsByTagName("form").length > 0 ) {
			this.fixElementStyle (ndDocument, "input");
			this.fixElementStyle (ndDocument, "textarea");
			this.fixElementStyle (ndDocument, "select");
			this.fixElementStyle (ndDocument, "option");
		}

		if ( ndDocument.links.length > 0 && ndDocument.styleSheets.length > 0 ) {
			sLinkcolor = ndDocument.defaultView.getComputedStyle(ndDocument.links[0],'').getPropertyValue("color");

			for ( i = 0; i < ndDocument.styleSheets[0].cssRules.length; ++i ) {
				if (ndDocument.styleSheets[0].cssRules[i].selectorText.indexOf("a:visited") != -1 ) {
					if ( (sVlinkcolor=ndDocument.styleSheets[0].cssRules[i].style.color) != "" ) {
						if ( sLinkcolor == sVlinkcolor ) {
							aVlinkcolorRGB = this.rgbToArray(sVlinkcolor);
							for ( j = 0; j < 3; j++ ) {
								aVlinkcolorRGB[j] -= 51;
								if (aVlinkcolorRGB[j] < 0) aVlinkcolorRGB[j] = 0;
							}
							ndDocument.styleSheets[0].cssRules[i].style.color = this.arrayToRgb(aVlinkcolorRGB);
							break;
						}
					}
				}
			}
		}

	},

	fixElementStyle: function ( ndDocument, tagname ) {
		if ( ndElements = ndDocument.getElementsByTagName(tagname) ) {
			for ( i = 0; i < ndElements.length; ++i ) {
				sElementColor = ndDocument.defaultView.getComputedStyle(ndElements[i],'').getPropertyValue("color");
				sElementBgcolor = ndDocument.defaultView.getComputedStyle(ndElements[i],'').getPropertyValue("background");
				if ( sElementBgcolor=="" )
					sElementBgcolor = ndDocument.defaultView.getComputedStyle(ndElements[i],'').getPropertyValue("background-color");

				aElementColorRGB = this.rgbToArray(sElementColor);
				aElementBgcolorRGB = this.rgbToArray(sElementBgcolor);

				if ( this.arrayRgbColorsSimilar(aElementColorRGB, aElementBgcolorRGB, 102) )
					ndElements[i].setAttribute("style", ndElements[i].getAttribute("style") +
							"; background-color: #CCCCCC; color: #000000;");
			}
		}
	},

	rgbToArray: function ( sRGB ) {
		sRGB = sRGB.replace("rgb(","").replace(")","");
		retval = sRGB.split(",");
		if ( retval.length == 3 ) return retval; else return null;
	},

	arrayToRgb: function ( aRGB ) {
		return "rgb(" + aRGB[0] + ", " + aRGB[1] + ", " + aRGB[2] + ")";
	},

	arrayRgbColorsSimilar: function ( aRGB1, aRGB2, diff ) {
		if ( aRGB1 && aRGB2 )
			for ( j = 0; j < 3; j++ )
				if (Math.abs(aRGB1[j] - aRGB2[j]) > diff) return false;
		return true;
	},

	hexToArray: function ( sHex ) {
		if ( !sHex || sHex.length != 7) return null;
		hexChar = "0123456789ABCDEF";
		sHex = sHex.substr(1).toUpperCase();
		retval = new Array(0, 0, 0);
		retval[0] = hexChar.indexOf(sHex[0])*16 + hexChar.indexOf(sHex[1]);
		retval[1] = hexChar.indexOf(sHex[2])*16 + hexChar.indexOf(sHex[3]);
		retval[2] = hexChar.indexOf(sHex[4])*16 + hexChar.indexOf(sHex[5]);
		return retval;
	},


	toggle: function()
	{
		if ( gPrefService.getBoolPref('txtbgfixer.enabled') ) {
			gPrefService.setBoolPref( 'txtbgfixer.enabled', false );
			gPrefService.setBoolPref( 'browser.display.use_document_colors', true );
			window._content.document.location.reload();
			this.setstatustxt( "Txt-Bgcolor Fixer off" );
		}
		else if ( gPrefService.getBoolPref('browser.display.use_document_colors') ) {
			gPrefService.setBoolPref( 'txtbgfixer.enabled', false );
			gPrefService.setBoolPref( 'browser.display.use_document_colors', false );
			window._content.document.location.reload();
			this.setstatustxt( "Txt-Bgcolor Fixer on" );
		}
		else {
			gPrefService.setBoolPref( 'txtbgfixer.enabled', true );
			gPrefService.setBoolPref( 'browser.display.use_document_colors', true );
			window._content.document.location.reload();
			this.setstatustxt( "Txt-Bgcolor Fixer forcing user-defined colors" );
		}
	},


	setstatustxt: function (msg)
	{
		document.getElementById("statusbar-display").label = msg;
	}


}

function txtbgfixerLoadWindow (e) {
	objTxtbgfixerBrowser.onload (e);
}

window.addEventListener ("load", txtbgfixerLoadWindow, true);
